searchNodes=[{"doc":"Data Validation for Elixir.","ref":"Vex.html","title":"Vex","type":"module"},{"doc":"","ref":"Vex.html#errors/1","title":"Vex.errors/1","type":"function"},{"doc":"","ref":"Vex.html#errors/2","title":"Vex.errors/2","type":"function"},{"doc":"","ref":"Vex.html#results/1","title":"Vex.results/1","type":"function"},{"doc":"","ref":"Vex.html#results/2","title":"Vex.results/2","type":"function"},{"doc":"","ref":"Vex.html#valid?/1","title":"Vex.valid?/1","type":"function"},{"doc":"","ref":"Vex.html#valid?/2","title":"Vex.valid?/2","type":"function"},{"doc":"","ref":"Vex.html#validate/1","title":"Vex.validate/1","type":"function"},{"doc":"","ref":"Vex.html#validate/2","title":"Vex.validate/2","type":"function"},{"doc":"Lookup a validator from configured sourcesExamples iex&gt; Vex.validator(:presence) Vex.Validators.Presence iex&gt; Vex.validator(:exclusion) Vex.Validators.Exclusion","ref":"Vex.html#validator/1","title":"Vex.validator/1","type":"function"},{"doc":"Lookup a validator from given sourcesExamples iex&gt; Vex.validator(:presence, [[presence: :presence_stub]]) :presence_stub iex&gt; Vex.validator(:exclusion, [Vex.Validators]) Vex.Validators.Exclusion iex&gt; Vex.validator(:presence, [Vex.Validators, [presence: :presence_stub]]) Vex.Validators.Presence iex&gt; Vex.validator(:presence, [[presence: :presence_stub], Vex.Validators]) :presence_stub","ref":"Vex.html#validator/2","title":"Vex.validator/2","type":"function"},{"doc":"","ref":"Vex.Blank.html","title":"Vex.Blank","type":"protocol"},{"doc":"Whether an item is blank","ref":"Vex.Blank.html#blank?/1","title":"Vex.Blank.blank?/1","type":"function"},{"doc":"","ref":"Vex.Blank.html#t:t/0","title":"Vex.Blank.t/0","type":"type"},{"doc":"Implementation of this behaviour should be set in validator options as :error_renderer or in :vex application config with same key.Common pattern is to expect :message key in validator options and if it not set use default_message (use get_message function for it).Result of message function appears in Vex.errors error tuple as last element, for those validators who use Vex.Validator.ErrorMessage (in general they should).","ref":"Vex.ErrorRenderer.html","title":"Vex.ErrorRenderer","type":"behaviour"},{"doc":"","ref":"Vex.ErrorRenderer.html#get_message/2","title":"Vex.ErrorRenderer.get_message/2","type":"function"},{"doc":"","ref":"Vex.ErrorRenderer.html#c:message/3","title":"Vex.ErrorRenderer.message/3","type":"callback"},{"doc":"","ref":"Vex.Extract.html","title":"Vex.Extract","type":"protocol"},{"doc":"Extract an attribute's value","ref":"Vex.Extract.html#attribute/2","title":"Vex.Extract.attribute/2","type":"function"},{"doc":"Extract the validation settings","ref":"Vex.Extract.html#settings/1","title":"Vex.Extract.settings/1","type":"function"},{"doc":"","ref":"Vex.Extract.html#t:t/0","title":"Vex.Extract.t/0","type":"type"},{"doc":"Common validator behavior.","ref":"Vex.Validator.html","title":"Vex.Validator","type":"module"},{"doc":"Determine if a validation should be executed based on any conditions providedExamplesIf an attribute is/isn't present (non-blank):iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;new&quot;], if: :state) true iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;new&quot;], unless: :state) falseIf an attribute does/doesn't match a value:iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;new&quot;], if: [state: &quot;new&quot;]) true iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;persisted&quot;], if: [state: &quot;new&quot;]) false iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;new&quot;], unless: [state: &quot;new&quot;]) false iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;persisted&quot;], unless: [state: &quot;new&quot;]) trueIf the data does/doesn't match another custom condition:iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;], if: &amp;(&amp;1[:name] == &quot;foo&quot;)) true iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;], unless: &amp;(&amp;1[:name] == &quot;foo&quot;)) false iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;], if: &amp;(&amp;1[:name] != &quot;foo&quot;)) false iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;], unless: &amp;(&amp;1[:name] != &quot;foo&quot;)) trueIf the data does/doesn't match a list of conditions:iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;new&quot;], if: [name: &quot;foo&quot;, state: &quot;new&quot;]) true iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;persisted&quot;], if: [name: &quot;foo&quot;, state: &quot;new&quot;]) false iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;persisted&quot;], if_any: [name: &quot;foo&quot;, state: &quot;new&quot;]) true iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;persisted&quot;], if_any: [name: &quot;bar&quot;, state: &quot;new&quot;]) false iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;new&quot;], unless: [name: &quot;foo&quot;, state: &quot;new&quot;]) false iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;persisted&quot;], unless: [name: &quot;foo&quot;, state: &quot;new&quot;]) true iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;persisted&quot;], unless_any: [name: &quot;foo&quot;, state: &quot;new&quot;]) false iex&gt; Vex.Validator.validate?([name: &quot;foo&quot;, state: &quot;persisted&quot;], unless_any: [name: &quot;bar&quot;, state: &quot;new&quot;]) true","ref":"Vex.Validator.html#validate?/2","title":"Vex.Validator.validate?/2","type":"function"},{"doc":"","ref":"Vex.Validator.Source.html","title":"Vex.Validator.Source","type":"protocol"},{"doc":"","ref":"Vex.Validator.Source.html#lookup/2","title":"Vex.Validator.Source.lookup/2","type":"function"},{"doc":"","ref":"Vex.Validator.Source.html#t:t/0","title":"Vex.Validator.Source.t/0","type":"type"},{"doc":"Ensure a value is absent.Vex uses the Vex.Blank protocol to determine &quot;absence.&quot; Notably, empty strings and collections are considered absent.Options:message: Optional. A custom error message. May be in EEx format and use the fields described in &quot;Custom Error Messages,&quot; below.Examplesiex&gt; Vex.Validators.Absence.validate(1, true) {:error, &quot;must be absent&quot;} iex&gt; Vex.Validators.Absence.validate(nil, true) :ok iex&gt; Vex.Validators.Absence.validate(false, true) :ok iex&gt; Vex.Validators.Absence.validate(&quot;&quot;, true) :ok iex&gt; Vex.Validators.Absence.validate([], true) :ok iex&gt; Vex.Validators.Absence.validate([], true) :ok iex&gt; Vex.Validators.Absence.validate([1], true) {:error, &quot;must be absent&quot;} iex&gt; Vex.Validators.Absence.validate({1}, true) {:error, &quot;must be absent&quot;}Custom Error MessagesCustom error messages (in EEx format), provided as :message, can use the following values:iex&gt; Vex.Validators.Absence.__validator__(:message_fields) [value: &quot;The bad value&quot;]An example:iex&gt; Vex.Validators.Absence.validate([1], message: &quot;can&#39;t be &lt;%= inspect value %&gt;&quot;) {:error, &quot;can&#39;t be [1]&quot;}","ref":"Vex.Validators.Absence.html","title":"Vex.Validators.Absence","type":"module"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/2.","ref":"Vex.Validators.Absence.html#validate/2","title":"Vex.Validators.Absence.validate/2","type":"function"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/3.","ref":"Vex.Validators.Absence.html#validate/3","title":"Vex.Validators.Absence.validate/3","type":"function"},{"doc":"Ensure an attribute is set to a positive (or custom) value.For use especially with &quot;acceptance of terms&quot; checkboxes in web applications.Options:as: Optional. A custom value (eg, &quot;yes&quot;). By default any &quot;truthy&quot; value constitutes acceptance.:message: Optional. A custom error message. May be in EEx format and use the fields described in &quot;Custom Error Messages,&quot; below.Examplesiex&gt; Vex.Validators.Acceptance.validate(1, true) :ok iex&gt; Vex.Validators.Acceptance.validate(nil, true) {:error, &quot;must be accepted&quot;} iex&gt; Vex.Validators.Acceptance.validate(nil, message: &quot;must be accepted!&quot;) {:error, &quot;must be accepted!&quot;} iex&gt; Vex.Validators.Acceptance.validate(1, [as: &quot;yes&quot;]) {:error, ~S(must be accepted with `&quot;yes&quot;`)} iex&gt; Vex.Validators.Acceptance.validate(&quot;verily&quot;, [as: &quot;verily&quot;]) :okCustom Error MessagesCustom error messages (in EEx format), provided as :message, can use the following values:iex&gt; Vex.Validators.Acceptance.__validator__(:message_fields) [value: &quot;The bad value&quot;]An example:iex&gt; Vex.Validators.Acceptance.validate(nil, message: &quot;&lt;%= inspect value %&gt; doesn&#39;t count as accepted&quot;) {:error, &quot;nil doesn&#39;t count as accepted&quot;}","ref":"Vex.Validators.Acceptance.html","title":"Vex.Validators.Acceptance","type":"module"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/2.","ref":"Vex.Validators.Acceptance.html#validate/2","title":"Vex.Validators.Acceptance.validate/2","type":"function"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/3.","ref":"Vex.Validators.Acceptance.html#validate/3","title":"Vex.Validators.Acceptance.validate/3","type":"function"},{"doc":"Ensure a value meets a custom criteria.Provide a function that will accept a value and return a true/false result.OptionsNone, a function with arity 1 must be provided.:function: The function to check. Should have an arity of 1 and return true/false.:message: Optional. A custom error message. May be in EEx format and use the fields described in &quot;Custom Error Messages,&quot; below.The function can be provided in place of the keyword list if no other options are needed.Examplesiex&gt; Vex.Validators.By.validate(2, &amp;(&amp;1 == 2)) :ok iex&gt; Vex.Validators.By.validate(3, &amp;(&amp;1 == 2)) {:error, &quot;must be valid&quot;} iex&gt; Vex.Validators.By.validate([&quot;foo&quot;, &quot;foo&quot;], &amp;is_list/1) :ok iex&gt; Vex.Validators.By.validate(&quot;sgge&quot;, fn (word) -&gt; word |&gt; String.reverse == &quot;eggs&quot; end) :ok iex&gt; Vex.Validators.By.validate(nil, [function: &amp;is_list/1, allow_nil: true]) :ok iex&gt; Vex.Validators.By.validate({}, [function: &amp;is_list/1, allow_blank: true]) :ok iex&gt; Vex.Validators.By.validate([1], [function: &amp;is_list/1, message: &quot;must be a list&quot;]) :ok iex&gt; Vex.Validators.By.validate(&quot;a&quot;, [function: &amp;is_list/1, message: &quot;must be a list&quot;]) {:error, &quot;must be a list&quot;} iex&gt; Vex.Validators.By.validate( ...&gt; &quot;a&quot;, [function: fn (v) when is_list(v) -&gt; :ok ...&gt; (v) -&gt; {:error, {:not_list, v}} end]) {:error, {:not_list, &quot;a&quot;}} iex&gt; Vex.Validators.By.validate( ...&gt; [], [function: fn (v) when is_list(v) -&gt; :ok ...&gt; (v) -&gt; {:error, {:not_list, v}} end]) :okCustom Error MessagesCustom error messages (in EEx format), provided as :message, can use the following values:iex&gt; Vex.Validators.By.__validator__(:message_fields) [value: &quot;The bad value&quot;]An example:iex&gt; Vex.Validators.By.validate(&quot;blah&quot;, [function: &amp;is_list/1, message: &quot;&lt;%= inspect value %&gt; isn&#39;t a list&quot;]) {:error, ~S(&quot;blah&quot; isn&#39;t a list)}","ref":"Vex.Validators.By.html","title":"Vex.Validators.By","type":"module"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/2.","ref":"Vex.Validators.By.html#validate/2","title":"Vex.Validators.By.validate/2","type":"function"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/3.","ref":"Vex.Validators.By.html#validate/3","title":"Vex.Validators.By.validate/3","type":"function"},{"doc":"Ensure a value, if provided, is equivalent to a second value.Generally used to check, eg, a password and password confirmation.Note: This validator is treated differently by Vex, in that two values are passed to it.Options:message: Optional. A custom error message. May be in EEx format and use the fields described in &quot;Custom Error Messages,&quot; below.Examplesiex&gt; Vex.Validators.Confirmation.validate([&quot;foo&quot;, &quot;bar&quot;], true) {:error, &quot;must match its confirmation&quot;} iex&gt; Vex.Validators.Confirmation.validate([&quot;foo&quot;, &quot;foo&quot;], true) :ok iex&gt; Vex.Validators.Confirmation.validate([&quot;foo&quot;, &quot;bar&quot;], message: &quot;&lt;%= confirmation %&gt; isn&#39;t the same as &lt;%= value %&gt;!&quot;) {:error, &quot;bar isn&#39;t the same as foo!&quot;} iex&gt; Vex.Validators.Confirmation.validate([nil, &quot;bar&quot;], true) :ok iex&gt; Vex.Validators.Confirmation.validate([&quot;foo&quot;, nil], true) {:error, &quot;must match its confirmation&quot;} iex&gt; Vex.Validators.Confirmation.validate([&quot;foo&quot;, nil], message: &quot;must match!&quot;) {:error, &quot;must match!&quot;} iex&gt; Vex.Validators.Confirmation.validate([&quot;&quot;, &quot;unneeded&quot;], [allow_blank: true]) :okCustom Error MessagesCustom error messages (in EEx format), provided as :message, can use the following values:iex&gt; Vex.Validators.Confirmation.__validator__(:message_fields) [value: &quot;The value to confirm&quot;, confirmation: &quot;Bad confirmation value&quot;]An example:iex&gt; Vex.Validators.Confirmation.validate([&quot;foo&quot;, nil], message: &quot;&lt;%= inspect confirmation %&gt; doesn&#39;t match &lt;%= inspect value %&gt;&quot;) {:error, ~S(nil doesn&#39;t match &quot;foo&quot;)}","ref":"Vex.Validators.Confirmation.html","title":"Vex.Validators.Confirmation","type":"module"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/2.","ref":"Vex.Validators.Confirmation.html#validate/2","title":"Vex.Validators.Confirmation.validate/2","type":"function"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/3.","ref":"Vex.Validators.Confirmation.html#validate/3","title":"Vex.Validators.Confirmation.validate/3","type":"function"},{"doc":"Ensure a value is not a member of a list of values.Options:in: The list.:message: Optional. A custom error message. May be in EEx format and use the fields described in &quot;Custom Error Messages,&quot; below. The list can be provided in place of the keyword list if no other options are needed.Examplesiex&gt; Vex.Validators.Exclusion.validate(1, [1, 2, 3]) {:error, &quot;must not be one of [1, 2, 3]&quot;} iex&gt; Vex.Validators.Exclusion.validate(1, [in: [1, 2, 3]]) {:error, &quot;must not be one of [1, 2, 3]&quot;} iex&gt; Vex.Validators.Exclusion.validate(1, [in: [1, 2, 3], message: &quot;&lt;%= value %&gt; shouldn&#39;t be in &lt;%= inspect list %&gt;&quot;]) {:error, &quot;1 shouldn&#39;t be in [1, 2, 3]&quot;} iex&gt; Vex.Validators.Exclusion.validate(4, [1, 2, 3]) :ok iex&gt; Vex.Validators.Exclusion.validate(&quot;a&quot;, ~w(a b c)) {:error, ~S(must not be one of [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;])} iex&gt; Vex.Validators.Exclusion.validate(&quot;a&quot;, in: ~w(a b c), message: &quot;must not be abc, talkin&#39; &#39;bout 123&quot;) {:error, &quot;must not be abc, talkin&#39; &#39;bout 123&quot;}Custom Error MessagesCustom error messages (in EEx format), provided as :message, can use the following values:iex&gt; Vex.Validators.Exclusion.__validator__(:message_fields) [value: &quot;The bad value&quot;, list: &quot;List&quot;]An example:iex&gt; Vex.Validators.Exclusion.validate(&quot;a&quot;, in: ~w(a b c), message: &quot;&lt;%= inspect value %&gt; is a disallowed value&quot;) {:error, ~S(&quot;a&quot; is a disallowed value)}","ref":"Vex.Validators.Exclusion.html","title":"Vex.Validators.Exclusion","type":"module"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/2.","ref":"Vex.Validators.Exclusion.html#validate/2","title":"Vex.Validators.Exclusion.validate/2","type":"function"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/3.","ref":"Vex.Validators.Exclusion.html#validate/3","title":"Vex.Validators.Exclusion.validate/3","type":"function"},{"doc":"Ensure a value matches a regular expression.Options:with: The regular expression.:message: Optional. A custom error message. May be in EEx format and use the fields described in &quot;Custom Error Messages,&quot; below.The regular expression can be provided in place of the keyword list if no other options are needed.Examplesiex&gt; Vex.Validators.Format.validate(&quot;foo&quot;, ~r/^f/) :ok iex&gt; Vex.Validators.Format.validate(&quot;foo&quot;, ~r/o{3,}/) {:error, &quot;must have the correct format&quot;} iex&gt; Vex.Validators.Format.validate(&quot;foo&quot;, [with: ~r/^f/]) :ok iex&gt; Vex.Validators.Format.validate(&quot;bar&quot;, [with: ~r/^f/, message: &quot;must start with an f&quot;]) {:error, &quot;must start with an f&quot;} iex&gt; Vex.Validators.Format.validate(&quot;&quot;, [with: ~r/^f/, allow_blank: true]) :ok iex&gt; Vex.Validators.Format.validate(nil, [with: ~r/^f/, allow_nil: true]) :okCustom Error MessagesCustom error messages (in EEx format), provided as :message, can use the following values:iex&gt; Vex.Validators.Format.__validator__(:message_fields) [value: &quot;The bad value&quot;, pattern: &quot;The regex that didn&#39;t match&quot;]An example:iex&gt; Vex.Validators.Format.validate(&quot;bar&quot;, [with: ~r/&quot;^f&quot;/, message: &quot;&lt;%= value %&gt; doesn&#39;t start with an f&quot;]) {:error, &quot;bar doesn&#39;t start with an f&quot;}","ref":"Vex.Validators.Format.html","title":"Vex.Validators.Format","type":"module"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/2.","ref":"Vex.Validators.Format.html#validate/2","title":"Vex.Validators.Format.validate/2","type":"function"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/3.","ref":"Vex.Validators.Format.html#validate/3","title":"Vex.Validators.Format.validate/3","type":"function"},{"doc":"Ensure a value is a member of a list of values.Options:in: The list.:message: Optional. A custom error message. May be in EEx format and use the fields described in &quot;Custom Error Messages,&quot; below. The list can be provided in place of the keyword list if no other options are needed.Examplesiex&gt; Vex.Validators.Inclusion.validate(1, [1, 2, 3]) :ok iex&gt; Vex.Validators.Inclusion.validate(1, [in: [1, 2, 3]]) :ok iex&gt; Vex.Validators.Inclusion.validate(4, [1, 2, 3]) {:error, &quot;must be one of [1, 2, 3]&quot;} iex&gt; Vex.Validators.Inclusion.validate(&quot;a&quot;, ~w(a b c)) :ok iex&gt; Vex.Validators.Inclusion.validate(nil, ~w(a b c)) {:error, ~S(must be one of [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;])} iex&gt; Vex.Validators.Inclusion.validate(nil, [in: ~w(a b c), allow_nil: true]) :ok iex&gt; Vex.Validators.Inclusion.validate(&quot;&quot;, [in: ~w(a b c), allow_blank: true]) :okCustom Error MessagesCustom error messages (in EEx format), provided as :message, can use the following values:iex&gt; Vex.Validators.Inclusion.__validator__(:message_fields) [value: &quot;The bad value&quot;, list: &quot;List&quot;]An example:iex&gt; Vex.Validators.Inclusion.validate(&quot;a&quot;, in: [1, 2, 3], message: &quot;&lt;%= inspect value %&gt; is not an allowed value&quot;) {:error, ~S(&quot;a&quot; is not an allowed value)}","ref":"Vex.Validators.Inclusion.html","title":"Vex.Validators.Inclusion","type":"module"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/2.","ref":"Vex.Validators.Inclusion.html#validate/2","title":"Vex.Validators.Inclusion.validate/2","type":"function"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/3.","ref":"Vex.Validators.Inclusion.html#validate/3","title":"Vex.Validators.Inclusion.validate/3","type":"function"},{"doc":"Ensure a value's length meets a constraint.OptionsAt least one of the following must be provided::min: The value is at least this long:max: The value is at most this long:in: The value's length is within this Range:is: The value's length is exactly this amount.The length for :is can be provided instead of the options keyword list. The :is is available for readability purposes.Optional::tokenizer: A function with arity 1 used to split up a value for length checking. By default binarys are broken up using String.graphemes and all other values (eg, lists) are passed through intact. See Vex.Validators.tokens/1.:message: Optional. A custom error message. May be in EEx format and use the fields described in &quot;Custom Error Messages,&quot; below.Examplesiex&gt; Vex.Validators.Length.validate(&quot;foo&quot;, 3) :ok iex&gt; Vex.Validators.Length.validate(&quot;foo&quot;, 2) {:error, &quot;must have a length of 2&quot;} iex&gt; Vex.Validators.Length.validate(nil, [is: 2, allow_nil: true]) :ok iex&gt; Vex.Validators.Length.validate(&quot;&quot;, [is: 2, allow_blank: true]) :ok iex&gt; Vex.Validators.Length.validate(&quot;foo&quot;, min: 2, max: 8) :ok iex&gt; Vex.Validators.Length.validate(&quot;foo&quot;, min: 4) {:error, &quot;must have a length of at least 4&quot;} iex&gt; Vex.Validators.Length.validate(&quot;foo&quot;, max: 2) {:error, &quot;must have a length of no more than 2&quot;} iex&gt; Vex.Validators.Length.validate(&quot;foo&quot;, max: 2, message: &quot;must be the right length&quot;) {:error, &quot;must be the right length&quot;} iex&gt; Vex.Validators.Length.validate(&quot;foo&quot;, is: 3) :ok iex&gt; Vex.Validators.Length.validate(&quot;foo&quot;, is: 2) {:error, &quot;must have a length of 2&quot;} iex&gt; Vex.Validators.Length.validate(&quot;foo&quot;, in: 1..6) :ok iex&gt; Vex.Validators.Length.validate(&quot;foo&quot;, in: 8..10) {:error, &quot;must have a length between 8 and 10&quot;} iex&gt; Vex.Validators.Length.validate(&quot;four words are here&quot;, max: 4, tokenizer: &amp;String.split/1) :okCustom Error MessagesCustom error messages (in EEx format), provided as :message, can use the following values:iex&gt; Vex.Validators.Length.__validator__(:message_fields) [value: &quot;Bad value&quot;, tokens: &quot;Tokens from value&quot;, size: &quot;Number of tokens&quot;, min: &quot;Minimum acceptable value&quot;, max: &quot;Maximum acceptable value&quot;]An example:iex&gt; Vex.Validators.Length.validate(&quot;hello my darling&quot;, min: 4, tokenizer: &amp;String.split/1, ...&gt; message: &quot;&lt;%= length tokens %&gt; words isn&#39;t enough&quot;) {:error, &quot;3 words isn&#39;t enough&quot;}","ref":"Vex.Validators.Length.html","title":"Vex.Validators.Length","type":"module"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/2.","ref":"Vex.Validators.Length.html#validate/2","title":"Vex.Validators.Length.validate/2","type":"function"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/3.","ref":"Vex.Validators.Length.html#validate/3","title":"Vex.Validators.Length.validate/3","type":"function"},{"doc":"Ensure a value is a number.OptionsAt least one of the following must be provided::is: The value is a number (integer or float) or not.:equal_to: The value is a number equal to this number.:greater_than : The value is a number greater than this number.:greater_than_or_equal_to: The value is a number greater than or equal to this number.:less_than : The value is a number less than this number.:less_than_or_equal_to: The value is a number less than or equal to this number.Optional::message: A custom error message. May be in EEx format and use the fields described in Custom Error Messages.:allow_nil: A boolean whether to skip this validation for nil values.:allow_blank: A boolean whether to skip this validaton for blank values.The :is option can be provided in place of the keyword list if no other options are set. When multiple options are than the validator will do an and logic between them.ExamplesExamples when using the :is option:iex&gt; Vex.Validators.Number.validate(&quot;not_a_number&quot;, is: true) {:error, &quot;must be a number&quot;} iex&gt; Vex.Validators.Number.validate(3.14, is: true) :ok iex&gt; Vex.Validators.Number.validate(&quot;not_a_number&quot;, is: false) :ok iex&gt; Vex.Validators.Number.validate(3.14, is: false) {:error, &quot;must not be a number&quot;}Examples when using the boolean value in options for the :is option:iex&gt; Vex.Validators.Number.validate(&quot;not_a_number&quot;, true) {:error, &quot;must be a number&quot;} iex&gt; Vex.Validators.Number.validate(3.14, true) :ok iex&gt; Vex.Validators.Number.validate(&quot;not_a_number&quot;, false) :ok iex&gt; Vex.Validators.Number.validate(3.14, false) {:error, &quot;must not be a number&quot;}Examples when using the :equal_to option:iex&gt; Vex.Validators.Number.validate(3.14, equal_to: 1.41) {:error, &quot;must be a number equal to 1.41&quot;} iex&gt; Vex.Validators.Number.validate(3.14, equal_to: 3.14) :ok iex&gt; Vex.Validators.Number.validate(3.14, equal_to: 6.28) {:error, &quot;must be a number equal to 6.28&quot;}Examples when using the :greater_than option:iex&gt; Vex.Validators.Number.validate(3.14, greater_than: 1.41) :ok iex&gt; Vex.Validators.Number.validate(3.14, greater_than: 3.14) {:error, &quot;must be a number greater than 3.14&quot;} iex&gt; Vex.Validators.Number.validate(3.14, greater_than: 6.28) {:error, &quot;must be a number greater than 6.28&quot;}Examples when using the :greater_than_or_equal_to option:iex&gt; Vex.Validators.Number.validate(3.14, greater_than_or_equal_to: 1.41) :ok iex&gt; Vex.Validators.Number.validate(3.14, greater_than_or_equal_to: 3.14) :ok iex&gt; Vex.Validators.Number.validate(3.14, greater_than_or_equal_to: 6.28) {:error, &quot;must be a number greater than or equal to 6.28&quot;}Examples when using the :less_than option:iex&gt; Vex.Validators.Number.validate(3.14, less_than: 1.41) {:error, &quot;must be a number less than 1.41&quot;} iex&gt; Vex.Validators.Number.validate(3.14, less_than: 3.14) {:error, &quot;must be a number less than 3.14&quot;} iex&gt; Vex.Validators.Number.validate(3.14, less_than: 6.28) :okExamples when using the :less_than_or_equal_to option:iex&gt; Vex.Validators.Number.validate(3.14, less_than_or_equal_to: 1.41) {:error, &quot;must be a number less than or equal to 1.41&quot;} iex&gt; Vex.Validators.Number.validate(3.14, less_than_or_equal_to: 3.14) :ok iex&gt; Vex.Validators.Number.validate(3.14, less_than_or_equal_to: 6.28) :okExamples when using the combinations of the above options:iex&gt; Vex.Validators.Number.validate(&quot;not_a_number&quot;, is: true, greater_than: 0, less_than_or_equal_to: 3.14) {:error, &quot;must be a number&quot;} iex&gt; Vex.Validators.Number.validate(0, is: true, greater_than: 0, less_than_or_equal_to: 3.14) {:error, &quot;must be a number greater than 0&quot;} iex&gt; Vex.Validators.Number.validate(1.41, is: true, greater_than: 0, less_than_or_equal_to: 3.14) :ok iex&gt; Vex.Validators.Number.validate(3.14, is: true, greater_than: 0, less_than_or_equal_to: 3.14) :ok iex&gt; Vex.Validators.Number.validate(6.28, is: true, greater_than: 0, less_than_or_equal_to: 3.14) {:error, &quot;must be a number less than or equal to 3.14&quot;}Custom Error MessagesCustom error messages (in EEx format), provided as :message, can use the following values:iex&gt; Vex.Validators.Number.__validator__(:message_fields) [ value: &quot;Bad value&quot;, is: &quot;Is number&quot;, equal_to: &quot;Equal to number&quot;, greater_than: &quot;Greater than number&quot;, greater_than_or_equal_to: &quot;Greater than or equal to number&quot;, less_than: &quot;Less than number&quot;, less_than_or_equal_to: &quot;Less than or equal to number&quot; ]An example:iex&gt; Vex.Validators.Number.validate(3.14, less_than: 1.41, ...&gt; message: &quot;&lt;%= inspect value %&gt; should be less than &lt;%= less_than %&gt;&quot;) {:error, &quot;3.14 should be less than 1.41&quot;}","ref":"Vex.Validators.Number.html","title":"Vex.Validators.Number","type":"module"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/2.","ref":"Vex.Validators.Number.html#validate/2","title":"Vex.Validators.Number.validate/2","type":"function"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/3.","ref":"Vex.Validators.Number.html#validate/3","title":"Vex.Validators.Number.validate/3","type":"function"},{"doc":"Ensure a value is present.Vex uses the Vex.Blank protocol to determine &quot;presence.&quot; Notably, empty strings and collections are not considered present.Options:message: Optional. A custom error message. May be in EEx format and use the fields described in &quot;Custom Error Messages,&quot; below.Examplesiex&gt; Vex.Validators.Presence.validate(1, true) :ok iex&gt; Vex.Validators.Presence.validate(nil, true) {:error, &quot;must be present&quot;} iex&gt; Vex.Validators.Presence.validate(false, true) {:error, &quot;must be present&quot;} iex&gt; Vex.Validators.Presence.validate(&quot;&quot;, true) {:error, &quot;must be present&quot;} iex&gt; Vex.Validators.Presence.validate([], true) {:error, &quot;must be present&quot;} iex&gt; Vex.Validators.Presence.validate([], true) {:error, &quot;must be present&quot;} iex&gt; Vex.Validators.Presence.validate([1], true) :ok iex&gt; Vex.Validators.Presence.validate({1}, true) :okCustom Error MessagesCustom error messages (in EEx format), provided as :message, can use the following values:iex&gt; Vex.Validators.Presence.__validator__(:message_fields) [value: &quot;The bad value&quot;]An example:iex&gt; Vex.Validators.Presence.validate([], message: &quot;needs to be more sizable than &lt;%= inspect value %&gt;&quot;) {:error, &quot;needs to be more sizable than []&quot;}","ref":"Vex.Validators.Presence.html","title":"Vex.Validators.Presence","type":"module"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/2.","ref":"Vex.Validators.Presence.html#validate/2","title":"Vex.Validators.Presence.validate/2","type":"function"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/3.","ref":"Vex.Validators.Presence.html#validate/3","title":"Vex.Validators.Presence.validate/3","type":"function"},{"doc":"Ensure a value is a valid UUID string.OptionsAt least one of the following must be provided::format: Required. An atom that defines the UUID format of the value::default: The value must be a string with format xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxxx.:hex: The value must be a string with the format xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx.:urn: The value must be a string with the format urn:uuid:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxxx.:any: The value must be a string of any of the supported formats (:default, :hex or :urn).:not_any: The value must not be a valid UUID string.Note: x is a hex number.Optional::message: A custom error message. May be in EEx format and use the fields described in Custom Error Messages.:allow_nil: A boolean whether to skip this validation for nil values.:allow_blank: A boolean whether to skip this validaton for blank values.The value for :format can be provided instead of the options keyword list. Additionally, if the options is a boolean value, then:true: Is the same as the [format: :any] options.false: Is the same as the [format: :not_any] options.ExamplesExamples when using the :any or true options:iex&gt; Vex.Validators.Uuid.validate(&quot;02aa7f48-3ccd-11e4-b63e-14109ff1a304&quot;, format: :any) :ok iex&gt; Vex.Validators.Uuid.validate(&quot;02aa7f48-3ccd-11e4-b63e-14109ff1a30&quot;, format: :any) {:error, &quot;must be a valid UUID string&quot;} iex&gt; Vex.Validators.Uuid.validate(&quot;02aa7f48-3ccd-11e4-b63e-14109ff1a304&quot;, true) :ok iex&gt; Vex.Validators.Uuid.validate(&quot;02aa7f48-3ccd-11e4-b63e-14109ff1a30&quot;, true) {:error, &quot;must be a valid UUID string&quot;}Examples when using the :not_any or false options:iex&gt; Vex.Validators.Uuid.validate(&quot;not_a_uuid&quot;, format: :not_any) :ok iex&gt; Vex.Validators.Uuid.validate(&quot;02aa7f48-3ccd-11e4-b63e-14109ff1a304&quot;, format: :not_any) {:error, &quot;must not be a valid UUID string&quot;} iex&gt; Vex.Validators.Uuid.validate(&quot;not_a_uuid&quot;, false) :ok iex&gt; Vex.Validators.Uuid.validate(&quot;02aa7f48-3ccd-11e4-b63e-14109ff1a304&quot;, false) {:error, &quot;must not be a valid UUID string&quot;}Examples when using the :default option:iex&gt; Vex.Validators.Uuid.validate(&quot;02aa7f48-3ccd-11e4-b63e-14109ff1a304&quot;, format: :default) :ok iex&gt; Vex.Validators.Uuid.validate(&quot;02aa7f483ccd11e4b63e14109ff1a304&quot;, format: :default) {:error, &quot;must be a valid UUID string in default format&quot;}Examples when using the :hex option:iex&gt; Vex.Validators.Uuid.validate(&quot;02aa7f483ccd11e4b63e14109ff1a304&quot;, format: :hex) :ok iex&gt; Vex.Validators.Uuid.validate(&quot;urn:uuid:02aa7f48-3ccd-11e4-b63e-14109ff1a304&quot;, format: :hex) {:error, &quot;must be a valid UUID string in hex format&quot;}Examples when using the :urn option:iex&gt; Vex.Validators.Uuid.validate(&quot;urn:uuid:02aa7f48-3ccd-11e4-b63e-14109ff1a304&quot;, format: :urn) :ok iex&gt; Vex.Validators.Uuid.validate(&quot;02aa7f48-3ccd-11e4-b63e-14109ff1a304&quot;, format: :urn) {:error, &quot;must be a valid UUID string in urn format&quot;}Custom Error MessagesCustom error messages (in EEx format), provided as :message, can use the following values:iex&gt; Vex.Validators.Uuid.__validator__(:message_fields) [value: &quot;Bad value&quot;, format: &quot;The UUID format&quot;]An example:iex&gt; Vex.Validators.Uuid.validate(&quot;not_a_uuid&quot;, format: :any, ...&gt; message: &quot;&lt;%= value %&gt; should be &lt;%= format %&gt; UUID&quot;) {:error, &quot;not_a_uuid should be any UUID&quot;}","ref":"Vex.Validators.Uuid.html","title":"Vex.Validators.Uuid","type":"module"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/2.","ref":"Vex.Validators.Uuid.html#validate/2","title":"Vex.Validators.Uuid.validate/2","type":"function"},{"doc":"Callback implementation for c:Vex.Validator.Behaviour.validate/3.","ref":"Vex.Validators.Uuid.html#validate/3","title":"Vex.Validators.Uuid.validate/3","type":"function"},{"doc":"","ref":"Vex.InvalidValidatorError.html","title":"Vex.InvalidValidatorError","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Vex.InvalidValidatorError.html#message/1","title":"Vex.InvalidValidatorError.message/1","type":"function"},{"doc":"VexAn extensible data validation library for Elixir.Can be used to check different data types for compliance with criteria.Ships with built-in validators to check for attribute presence, absence, inclusion, exclusion, format, length, acceptance, and by a custom function. You can easily define new validators and override existing ones.","ref":"readme.html","title":"Vex","type":"extras"},{"doc":"Rails ActiveModel ValidationsClojure's Validateur","ref":"readme.html#inspired-by","title":"Vex - Inspired by","type":"extras"},{"doc":"Note the examples below use Vex.valid?/2, with the validations to check explicitly provided as the second argument. For information on how validation configuration can be provided as part of a single argument (eg, packaged with the data to check passed to Vex.valid?/1) see &quot;Configuring Validations&quot; below.Note all validations can be skipped based on :if and :unless conditions given as options. See &quot;Validation Conditions&quot; further below for more information.PresenceEnsure a value is present:Vex.valid? post, title: [presence: true]See the documentation on Vex.Validators.Presence for details on available options.AbsenceEnsure a value is absent (blank)Vex.valid? post, byline: [absence: true]See the documentation on Vex.Validators.Absence for details on available options.InclusionEnsure a value is in a list of values:Vex.valid? post, category: [inclusion: [&quot;politics&quot;, &quot;food&quot;]]This validation can be skipped for nil or blank values by including allow_nil: true and/or allow_blank: true.See the documentation on Vex.Validators.Inclusion for details on available options.ExclusionEnsure a value is not in a list of values:Vex.valid? post, category: [exclusion: [&quot;oped&quot;, &quot;lifestyle&quot;]]See the documentation on Vex.Validators.Exclusion for details on available options.FormatEnsure a value matches a regular expression:Vex.valid? widget, identifier: [format: ~r/(^id-)/]This validation can be skipped for nil or blank values by including allow_nil: true and/or allow_blank: true.See the documentation on Vex.Validators.Format for details on available options.LengthEnsure a value's length is at least a given size:Vex.valid? user, username: [length: [min: 2]]Ensure a value's length is at or below a given size:Vex.valid? user, username: [length: [max: 10]]Ensure a value's length is within a range (inclusive):Vex.valid? user, username: [length: [in: 2..10]]This validation can be skipped for nil or blank values by including allow_nil: true and/or allow_blank: true.See the documentation on Vex.Validators.Length for details on available options.NumberEnsure a value is a number greater than a given number:Vex.valid? value, number: [greater_than: 2]Ensure a value is a number less than or equal to a given number:Vex.valid? value, number: [less_than_or_equal_to: 10]Ensure a value is a number is within a given range:Vex.valid? value, number: [greater_than_or_equal_to: 0, less_than: 10]This validation can be skipped for nil or blank values by including allow_nil: true or allow_blank: true respectively in the options.See the documentation on Vex.Validators.Number for details on available options.UUIDEnsure a value is a valid UUID string:Vex.valid? value, uuid: trueEnsure a value is a valid UUID string in a given format:Vex.valid? value, uuid: [format: :hex]This validation can be skipped for nil or blank values by including allow_nil: true or allow_blank: true respectively in the options.See the documentation on Vex.Validators.Uuid for details on available options.AcceptanceEnsure an attribute is set to a positive (or custom) value. For use expecially with &quot;acceptance of terms&quot; checkboxes in web applications.Vex.valid?(user, accepts_terms: [acceptance: true])To check for a specific value, use :as:Vex.valid?(user, accepts_terms: [acceptance: [as: &quot;yes&quot;]])See the documentation on Vex.Validators.Acceptance for details on available options.ConfirmationEnsure a value has a matching confirmation:Vex.valid? user, password: [confirmation: true]The above would ensure the values of password and password_confirmation are equivalent.This validation can be skipped for nil or blank values by including allow_nil: true and/or allow_blank: true.See the documentation on Vex.Validators.confirmation for details on available options.Custom FunctionYou can also just provide a custom function for validation instead of a validator name:Vex.valid?(user, password: fn (pass) -&gt; byte_size(pass) &gt; 4 end) Vex.valid? user, password: &amp;valid_password?/1 Vex.valid?(user, password: &amp;(&amp;1 != &quot;god&quot;))Instead of returning a boolean the validate function may return :ok on success, or {:error, &quot;a message&quot;} on error:Vex.valid?(user, password: fn (password) -&gt; if valid_password?(password) do :ok else {:error, &quot;\#{password} isn&#39;t a valid password&quot;} end end)Or explicitly using :by:Vex.valid?(user, age: [by: &amp;(&amp;1 &gt; 18)])This validation can be skipped for nil or blank values by including allow_nil: true and/or allow_blank: true.See the documentation on Vex.Validators.By for details on available options.","ref":"readme.html#supported-validations","title":"Vex - Supported Validations","type":"extras"},{"doc":"A validation can be made applicable (or unapplicable) by using the :if, :if_any, :unless and :unless_any options.Note Vex.results will return tuples with :not_applicable for validations that are skipped as a result of failing conditions.Based on another attribute's presenceRequire a post to have a body of at least 200 bytes unless a non-blank reference_url is provided.iex&gt; Vex.valid?(post, body: [length: [min: 200, unless: :reference_url]])Based on other attributes' presenceRequire a post to have a body of at least 200 bytes unless a non-blank reference_urland category are provided.iex&gt; Vex.valid?(post, body: [length: [min: 200, unless: [:reference_url, :category]]])Require a post to have a body of at least 200 bytes unless a non-blank reference_url or category is provided.iex&gt; Vex.valid?(post, body: [length: [min: 200, unless_any: [:reference_url, :category]]])Based on another attribute's valueOnly require a password if the state of a user is :new:iex&gt; Vex.valid?(user, password: [presence: [if: [state: :new]]]Based on other attributes' valueOnly require a password if the state of a user is :new and she is not from Facebook:iex&gt; Vex.valid?(user, password: [presence: [if: [state: :new, from_facebook: false]]]Only require a password if the state of a user is :new or she is not from Facebook:iex&gt; Vex.valid?(user, password: [presence: [if_any: [state: :new, from_facebook: false]]]Based on a custom functionDon't require users from Facebook to provide an email address:iex&gt; Vex.valid?(user, email: [presence: [unless: &amp;User.from_facebook?/1]]Require users less than 13 years of age to provide a parent's email address:iex&gt; Vex.valid?(user, parent_email: [presence: [if: &amp;(&amp;1.age &lt; 13)]]","ref":"readme.html#validation-conditions","title":"Vex - Validation Conditions","type":"extras"},{"doc":"The examples above use Vex.valid?/2, passing both the data to be validated and the validation settings. This is nice for ad hoc data validation, but wouldn't it be nice to just:Vex.valid?(data)... and have the data tell Vex which validations should be evaluated?In StructsIn your struct module, use Vex.Struct:defmodule User do defstruct username: nil, password: nil, password_confirmation: nil use Vex.Struct validates :username, presence: true, length: [min: 4], format: ~r/^[[:alpha:]][[:alnum:]]+$/ validates :password, length: [min: 4], confirmation: true endNote validates should only be used once per attribute.Once configured, you can use Vex.valid?/1:user = %User{username: &quot;actualuser&quot;, password: &quot;abcdefghi&quot;, password_confirmation: &quot;abcdefghi&quot;} Vex.valid?(user)You can also use valid? directly from the Module:user |&gt; User.valid?In Keyword ListsIn your list, just include a :_vex entry and use Vex.valid?/1:user = [username: &quot;actualuser&quot;, password: &quot;abcdefghi&quot;, password_confirmation: &quot;abcdefghi&quot;, _vex: [username: [presence: true, length: [min: 4], format: ~r/^[[:alpha:]][[:alnum:]]+$/]], password: [length: [min: 4], confirmation: true]] Vex.valid?(user)OthersJust implement the Vex.Extract protocol. Here's what was done to support keyword lists:defimpl Vex.Extract, for: List do def settings(data) do Keyword.get data, :_vex end def attribute(data, name) do Keyword.get data, name end end","ref":"readme.html#configuring-validations","title":"Vex - Configuring Validations","type":"extras"},{"doc":"For validity, it's the old standard, Vex.valid?/1:iex&gt; Vex.valid?(user) true(If you need to pass in the validations to use, do that as a second argument to Vex.valid?/2)You can access the raw validation results using Vex.results/1:iex&gt; Vex.results(user) [{:ok, :username, :presence}, {:ok, :username, :length}, {:ok, :username, :format}]If you only want the errors, use Vex.errors/1:iex&gt; Vex.errors(another_user) [{:error, :password, :length, &quot;must have a length of at least 4&quot;}, {:error, :password, :confirmation, &quot;must match its confirmation&quot;}]","ref":"readme.html#querying-results","title":"Vex - Querying Results","type":"extras"},{"doc":"By default Vex uses Vex.ErrorRenderers.EEx as default renderer, also have Vex.ErrorRenderers.Parameterized, and you have ability to define your own.For example if we want to use Linguist for internationalization, we can do the following: defmodule I18nErrorRenderer do @behaviour Vex.ErrorRenderer use Linguist.Vocabulary locale &quot;en&quot;, [ foo: [ too_short: &quot;too short, min %{min} chars&quot;, must_start_with_f: &quot;must start with an f&quot;, ], ] locale &quot;kr&quot;, [ foo: [ too_short: &quot;너무 짧으면, 최소 %{min} 개 문자&quot;, must_start_with_f: &quot;f로 시작해야합니다&quot;, ], ] def message(options, _default, context \\\\ []) do message = options[:message] || raise &quot;message is needed for proper i18n&quot; locale = options[:locale] || &quot;en&quot; t!(locale, message, context) end end result = Vex.validate([name: &quot;Foo&quot;], name: [ length: [ min: 4, error_renderer: I18nErrorRenderer, message: &quot;foo.too_short&quot; ], format: [ with: ~r/^f/, locale: &quot;kr&quot;, error_renderer: I18nErrorRenderer, message: &quot;foo.must_start_with_f&quot;, ] ]) assert {:error, [ {:error, :name, :length, &quot;too short, min 4 chars&quot;}, {:error, :name, :format, &quot;f로 시작해야합니다&quot;} ]} = resultWe can set error renderer globally:config :vex, error_renderer: Vex.ErrorRenderers.ParameterizedValidators declare a list of the available message fields and their descriptions by setting the module attribute @message_fields (see Vex.Validator.ErrorMessage), and the metadata is available for querying:iex&gt; Vex.Validators.Length.__validator__(:message_fields) [value: &quot;Bad value&quot;, tokens: &quot;Tokens from value&quot;, size: &quot;Number of tokens&quot;, min: &quot;Minimum acceptable value&quot;, max: &quot;Maximum acceptable value&quot;]","ref":"readme.html#error-message-renderers","title":"Vex - Error Message Renderers","type":"extras"},{"doc":"Custom error messages can be requested by validations when providing the :message option and can use EEx to insert fields specific to the validator, eg:validates :body, length: [min: 4, tokenizer: &amp;String.split/1, message: &quot;&lt;%= length tokens %&gt; words isn&#39;t enough&quot;]This could yield, in the case of a :body value &quot;hello my darling&quot;, the result:{:error, &quot;3 words isn&#39;t enough&quot;}","ref":"readme.html#custom-eex-error-renderer-messages","title":"Vex - Custom EEx Error Renderer Messages","type":"extras"},{"doc":"Validators are simply modules that implement validate/2 and return :ok or a tuple with :error and a message. They usually use Vex.Validator as well to get some common utilities for supporting :allow_nil, :allow_blank, and custom :message options:defmodule App.CurrencyValidator do use Vex.Validator def validate(value, options) do # Return :ok or {:error, &quot;a message&quot;} end endIf you wanted to make this validator available to Vex as the :currency validator so that you could do this:validates :amount, currency: trueYou just need to add a validator source so that Vex knows where to find it.A source can be anything that implements the Vex.Validator.Source protocol. We'll use a keyword list for this example. The implementation for List allows us to provide a simple mapping.Vex uses Application.get_env(:vex, :sources) to retrieve the configuration of sources, defaulting to [Vex.Validators]. We can set the configuration with Mix.Config, as in:config :vex, sources: [[currency: App.CurrencyValidator], Vex.Validators]Vex will consult the list of sources -- in order -- when looking for a validator. By putting our new source before Vex.Validators, we make it possible to override the built-in validators.Note: Without a sources configuration, Vex falls back to a default of [Vex.Validators].Using Modules as SourcesIf adding mappings to our keyword list source becomes tiresome, we can make use of the fact there's a Vex.Validator.Source implementation for Atom; we can provide a module name as a source instead (just as Vex does with Vex.Validators).config :vex, sources: [App.Validators, Vex.Validators]If given an atom, Vex will assume it refers to a module and try two strategies to retrieve a validator:If the module exports a validator/1 function, it will call that function, passing the validator name (eg, :currency)Otherwise, Vex will assume the validator module is the same as the source module plus a dot and the camelized validator name (eg, given a source of App.Validators, it would look for a :currency validator at App.Validators.Currency)In either case it will check the candidate validator for an exported validate/2 function.In the event no validators can be found for a name, a Vex.InvalidValidatorError will be raised.Checking Validator LookupTo see what validator Vex finds for a given validator name, use Vex.validator/1:iex&gt; Vex.validator(:currency) App.Validators.Currency","ref":"readme.html#adding-and-overriding-validators","title":"Vex - Adding and Overriding Validators","type":"extras"},{"doc":"Please fork and send pull requests (preferably from non-master branches), including tests (doctests or normal ExUnit.Case tests).Report bugs and request features via Issues; kudos if you do it from pull requests you submit that fix the bugs or add the features. ;)","ref":"readme.html#contributing","title":"Vex - Contributing","type":"extras"},{"doc":"Released under the MIT License.","ref":"readme.html#license","title":"Vex - License","type":"extras"}]